<template>
    <div class="list-view">
        <div class="filters-container">
            <el-form :model="form" size="mini" inline>
                <el-row>
                    <el-col :span="8">
                        <el-form-item label="活动名称">
                            <el-select
                                v-model="performanceId"
                                filterable
                                placeholder="展演活动名称"
                                @change="changeAddress"
                            >
                                <el-option
                                    v-for="item in performances"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item label="参赛专业">
                            <el-cascader
                                ref="artCascader"
                                style="width: 100%"
                                v-model="form.specialtyId"
                                :props="optionProps"
                                :options="artTypes"
                                :show-all-levels="false"
                                placeholder="请选择专业"
                                clearable
                            >
                            </el-cascader>
                        </el-form-item>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item label="节目编号">
                            <el-input placeholder="节目编号" v-model="form.id" clearable></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-collapse-transition>
                    <div v-show="showMore">
                        <el-row>
                            <el-col :span="8">
                                <el-form-item label="考级机构">
                                    <el-select
                                        v-model="form.gradingOrganizationId"
                                        clearable
                                        filterable
                                        placeholder="考级机构"
                                        style="width: 100%"
                                    >
                                        <el-option
                                            v-for="item in gradingOrganizationIdOptions"
                                            :key="item.value"
                                            :label="item.label"
                                            :value="item.value"
                                        >
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                            <el-col :span="8">
                                <el-form-item label="承办单位">
                                    <el-select
                                        v-model="form.organizationId"
                                        clearable
                                        filterable
                                        placeholder="承办单位"
                                        style="width: 100%"
                                    >
                                        <el-option
                                            v-for="item in organizationIdOptions"
                                            :key="item.value"
                                            :label="item.label"
                                            :value="item.value"
                                        >
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>

                            <el-col :span="8">
                                <el-form-item label="节目名称">
                                    <el-input placeholder="节目名称" v-model="form.name" clearable></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                    </div>
                </el-collapse-transition>
                <div style="width:100%;textAlign:center;margin-bottom:10px;">
                    <el-button
                        class="more"
                        round
                        type="primary"
                        :plain="!showMore"
                        :icon="showMore ? 'el-icon-arrow-up' : 'el-icon-arrow-down'"
                        @click="showMore = !showMore"
                        size="mini"
                        >{{ showMore ? '隐藏查询区域' : '显示查询区域' }}</el-button
                    >
                    <!-- <el-link
                        @click="showMore = !showMore"
                        :icon="showMore ? 'el-icon-arrow-up' : 'el-icon-arrow-down'"
                        :underline="false"
                        class="show"
                        >{{ showMore ? '隐藏查询区域' : '显示查询区域' }}</el-link
                    > -->
                </div>
                <el-form-item>
                    <el-button @click="getData" type="primary" icon="el-icon-search" size="mini">查询 </el-button>
                </el-form-item>
                <el-form-item>
                    <el-button @click="editRow(performanceId)">设置复审</el-button>
                    <el-button
                        @click="download"
                        type="primary"
                        icon="el-icon-download"
                        :loading="downloading"
                        :disabled="totalElements < 1"
                        >导出节目
                    </el-button>
                </el-form-item>
            </el-form>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="编号" width="80"> </el-table-column>
            <el-table-column prop="name" label="节目名称" min-width="70"> </el-table-column>
            <el-table-column prop="specialty" label="参赛专业" min-width="70"> </el-table-column>
            <el-table-column prop="gradingOrganization" label="考级机构" show-overflow-tooltip min-width="160">
            </el-table-column>
            <el-table-column prop="organization" label="承办单位" min-width="160"> </el-table-column>
            <el-table-column prop="examPoint" label="考级点" min-width="160"> </el-table-column>
            <el-table-column prop="participant" label="参赛人员" show-overflow-tooltip>
                <template slot-scope="{ row }">{{
                    row.participant ? row.participant.join(',') : row.participant
                }}</template>
            </el-table-column>
            <el-table-column prop="quantity" label="表演人数" min-width="70"> </el-table-column>
            <el-table-column prop="signedIn" label="状态" :formatter="signedInFormatter" v-if="!performance.online">
            </el-table-column>
            <el-table-column prop="myScore" label="专家平均分">
                <template slot-scope="{ row }">
                    <span v-if="row.myScore">{{ Math.round(row.myScore) }}</span>
                    <span v-else>暂无</span>
                </template>
            </el-table-column>
            <el-table-column prop="score" label="成绩">
                <template slot-scope="{ row }">
                    <span v-if="!row.second">
                        <span v-if="row.score">{{ Math.round(row.score) }}</span>
                        <span v-else>暂无</span>
                    </span>
                    <el-input-number
                        v-else
                        v-model="row.score"
                        size="mini"
                        label=""
                        :min="0"
                        :max="100"
                        :step="1"
                        :controls="true"
                        controls-position="right"
                        @change="saveRow(row)"
                        style="width: 80px"
                    >
                    </el-input-number>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="left" fixed="right" min-width="170">
                <template slot-scope="{ row, $index }">
                    <el-button @click="playVideo(row, $index)" size="mini" plain type="primary">查看作品</el-button>
                    <span v-if="performance.status == 'RATE'" style="margin-left:10px">
                        <el-button @click="row.second = true" size="mini" plain type="warning" v-if="!row.second"
                            >修改</el-button
                        >
                        <el-button @click="row.second = false" size="mini" plain type="danger" v-else>取消</el-button>
                    </span>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>

        <el-dialog
            :title="programme.name"
            class="videoDialog"
            destroy-on-close
            center
            append-to-body
            :visible.sync="showViedo"
            width="45vw"
        >
            <div class="dialog-content">
                <video
                    :src="programme.video"
                    controls
                    style="max-height: 600px; max-width: 100%; margin: 0 auto"
                    v-if="programme.video"
                >
                    您的浏览器不支持 video 标签。
                </video>
                <img
                    style="max-height: 600px; max-width: 100%; display: block; margin: auto"
                    :src="programme.annex"
                    alt=""
                    v-if="programme.annex"
                />
                <el-card shadow="never" style="width: 100%; margin: 10px auto">
                    <el-form :form="programme">
                        <el-form-item label="分数">
                            <span v-if="!programme.second">{{ Math.round(programme.score) }}</span>
                            <el-input-number
                                v-else
                                v-model="programme.score"
                                size="mini"
                                label=""
                                :min="0"
                                :max="100"
                                :step="1"
                                :controls="true"
                                controls-position="both"
                            >
                            </el-input-number>
                        </el-form-item>
                        <el-form-item>
                            <span v-if="performance.status == 'RATE'" style="margin-right: 10px">
                                <el-button
                                    size="mini"
                                    v-if="!programme.second"
                                    @click="programme.second = true"
                                    type="warning"
                                    >修改</el-button
                                >
                                <el-button size="mini" v-else @click="saveRow(programme)" type="primary"
                                    >保存</el-button
                                >
                                <el-button
                                    @click="programme.second = false"
                                    size="mini"
                                    plain
                                    type="danger"
                                    v-if="programme.second"
                                    >取消</el-button
                                >
                            </span>
                            <el-button size="mini" @click="move(-1)" :disabled="index == 0">上一个</el-button>
                            <el-button
                                size="mini"
                                @click="move(1)"
                                :disabled="(page - 1) * pageSize + index == totalElements - 1 || index >= pageSize - 1"
                                >下一个</el-button
                            >
                            <el-button @click="showViedo = false" size="mini">关闭</el-button>
                        </el-form-item>
                    </el-form>
                </el-card>
            </div>
        </el-dialog>
        <review-log :dialogVisible="isShow" :total="totalElements" @close="isShow = false" ref="public"></review-log>
    </div>
</template>
<script>
import delChild from '@/mixins/delChild';
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import ReviewLog from '../../components/ReviewLog';

export default {
    name: 'ProgScoreAdminList',
    mixins: [pageableTable, delChild],
    props: ['review'],
    components: { ReviewLog },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/programme/byScoreAdmin',
            downloading: false,
            form: {},
            dialogSign: false,
            performanceId: '',
            performances: [],
            performance: {},
            signedInOptions: [
                { label: '已签到', value: 'SIGNED_IN' },
                { label: '未签到', value: 'UNSIGNED' },
                { label: '已调整', value: 'ADJUSTED' }
            ],
            signForm: {},
            addresses: [],
            morning: true,
            date: new Date(),
            columnKeys: ['arrangeName'],
            addressList: [],
            showViedo: false,
            programme: {},
            index: 0,
            isShow: false,
            artTypes: [],
            optionProps: {
                value: 'id',
                label: 'name',
                children: 'children',
                multiple: false,
                emitPath: false,
                checkStrictly: true,
                expandTrigger: 'hover'
            },
            showMore: false,
            organizationIdOptions: [],
            gradingOrganizationIdOptions: []
        };
    },
    created() {
        // this.morning = isSameDay(addHours(new Date(), 12), new Date());
        this.$http
            .post('/gradingOrganization/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.gradingOrganizationIdOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/organization/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.organizationIdOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/artType/allList')
            .then(res => {
                this.artTypes = this.delChild(res);
            })
            .catch(e => {
                console.log(e);
            });
        this.$http
            .post(
                '/performance/all',
                {
                    size: 1000,
                    sort: 'year,desc',
                    query: {
                        publish: true
                    }
                },
                { body: 'json' }
            )
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.performances.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                    this.performanceId = res.content[0].id;
                    this.performance = res.content[0];
                    this.getData();
                    this.$http
                        .post('/performanceSchedule/all', { size: 100 }, { body: 'json' })
                        .then(res => {
                            if (res.content.length > 0) {
                                res.content.forEach(item => {
                                    this.addressList.push({
                                        value: item.address,
                                        pid: item.performanceId
                                    });
                                });
                            }
                        })
                        .catch(e => {
                            console.log(e);
                            this.$message.error(e.error);
                        });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        },
        showTable() {
            return this.backMap(this.tableData);
        }
    },
    methods: {
        signedInFormatter(row, column, cellValue, index) {
            let selectedOption = this.signedInOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        getBefore() {
            let data = {
                sort: 'score,desc',
                query: {}
            };
            if (this.form.gradingOrganizationId) {
                data.query.gradingOrganizationId = this.form.gradingOrganizationId;
            }
            if (this.form.organizationId) {
                data.query.organizationId = this.form.organizationId;
            }
            if (this.form.specialtyId) {
                data.query.code = this.getCode(this.form.specialtyId);
            }
            if (this.performanceId) {
                data.query.performanceId = this.performanceId;
            }
            if (this.form.name) {
                data.query.name = this.form.name;
            }
            if (this.form.id) {
                data.query.id = this.form.id;
            }
            return data;
        },
        beforeGetData() {
            let data = this.getBefore();
            data.query.programmeStatus = 'SUBMIT';
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        showSign(row) {
            this.dialogSign = true;
            this.signForm.id = row.id;
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        saveRow(row) {
            if (!row.score) {
                this.$message.warning('请输入评分');
                return;
            }
            this.$http
                .post('/programme/saveScore', {
                    id: row.id,
                    score: row.score
                })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.getData();
                    if (showViedo) {
                        this.programme = JSON.parse(res);
                    }
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        backMap(list, key = 'arrangeName', preActive = 0) {
            let _map = new Map();
            list.forEach((item, index) => {
                let info = {
                    active: index + preActive,
                    childNum: 1,
                    list: []
                };
                if (_map.has(item[key])) {
                    info = _map.get(item[key]);
                    info.list.push(item);
                    info.childNum = info.list.length;
                } else {
                    info.list.push(item);
                }

                _map.set(item[key], info);
            });

            let keyIndex = this.columnKeys.indexOf(key);
            if (keyIndex !== this.columnKeys.length - 1) {
                [..._map.keys()].forEach(item => {
                    let info = _map.get(item);
                    let childMap = this.backMap(info.list, this.columnKeys[keyIndex + 1], info.active);
                    _map.set(item, {
                        ...info,
                        childMap: childMap
                    });
                });
            }

            return _map;
        },
        getInfo(mapInfo = new Map(), keys = ['date']) {
            let info = {};
            keys.forEach(item => {
                if (mapInfo.has(item)) {
                    info = mapInfo.get(item);
                    mapInfo = mapInfo.get(item).childMap;
                }
            });
            return info;
        },
        objectSpanMethod({ row, column, rowIndex, columnIndex }) {
            let keyIndex = columnIndex;
            // if (column.label === '操作') {
            //     keyIndex = 2;
            // }

            if (keyIndex < this.columnKeys.length) {
                let keys = [...this.columnKeys].slice(0, keyIndex + 1).map(item => {
                    return row[item];
                });
                let info = this.getInfo(this.showTable, keys);
                if (rowIndex === info.active) {
                    return {
                        rowspan: info.childNum,
                        colspan: 1
                    };
                } else {
                    return {
                        rowspan: 0,
                        colspan: 0
                    };
                }
            }
        },
        playVideo(row, index) {
            this.index = index;
            this.showViedo = true;
            this.programme = row;
        },
        move(direction) {
            const end = direction + this.index;
            this.programme = { ...this.tableData[end] };
            this.index = end;
        },
        editRow(id) {
            this.isShow = true;
            this.$refs.public.init(id);
        },
        getCode(value) {
            return this.forTree(this.artTypes, value).code;
        },
        forTree(list, value) {
            var result = null;
            if (!list) {
                return;
            }
            for (var i in list) {
                if (result !== null) {
                    break;
                }
                var item = list[i];
                if (item.id == value) {
                    result = item;
                    break;
                } else if (item.children && item.children.length > 0) {
                    result = this.forTree(item.children, value);
                }
            }
            return result;
        },
        download() {
            this.downloading = true;

            let data = this.getBefore();
            data.size = 2000;
            this.$axios
                .get('/programme/excelScore', {
                    responseType: 'blob',
                    params: data
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        }
    }
};
</script>
<style lang="less" scoped>
.right {
    float: right;
}
/deep/.el-form-item--mini.el-form-item,
.el-form-item--small.el-form-item {
    margin-bottom: 10px;
}
.videoDialog {
    display: flex;
    align-items: center;
    justify-content: center;
    .el-dialog {
        max-width: 900px;
        margin-top: 0px;

        .close {
            position: absolute;
            right: 0px;
            top: -42px;
            width: 71px;
            height: 32px;
            background: #00000015;

            font-size: 12px;
            color: #fdffff;
            line-height: 32px;
            text-align: center;
            cursor: pointer;

            &:hover {
                background: #00000055;
            }
        }
    }
    .el-dialog__header {
        display: none;
    }

    .el-dialog__body {
        padding: 0;

        video {
            display: block;
            height: auto;
            width: 100%;
            outline: none;
        }
    }
}
.show {
    // background-color: #f9fafc;
    width: 96%;
    padding: 10px;
}
</style>
